/*
** varchar Header File	(Public)
*/


/***********************************************************************
** Standard header preamble.  Ensure singular inclusion, setup for
** function prototypes and c++ inclusion
*/

#ifndef MAIN_VARCHAR_H

#define MAIN_VARCHAR_H 1

#if defined(__STDC__) || defined(__cplusplus)
#  define __ANSI_PROTO(x)       x
#else
#  define __ANSI_PROTO(x)       ()
#endif

#ifdef __cplusplus
extern "C" {
#endif



/***********************************************************************
** Macro Definitions
*/


/***********************************************************************
** Type Definitions
*/

typedef struct {
	cache_t	*cacheEntry;
	char	buf[OFB_SIZE],
		*cp,
		*data;
	u_int	pos,
		segLen,
		dataLen,
		remain;
} vc_cursor;
	


/***********************************************************************
** Function Prototypes
*/

u_char *varcharRead __ANSI_PROTO((cache_t*, u_char*, int));
u_int varcharWrite __ANSI_PROTO((cache_t*, u_char*, int));
void varcharDelete __ANSI_PROTO((cache_t*,u_int));
int varcharCompare __ANSI_PROTO((cache_t*,u_char*,u_char*,int));
int varcharMatch __ANSI_PROTO((cache_t*,u_char*,char*,int,int));

char *varcharGetNext __ANSI_PROTO((vc_cursor *));
void *varcharDupCursor __ANSI_PROTO((vc_cursor*));
vc_cursor *varcharMakeCursor __ANSI_PROTO((cache_t*, u_char *, u_int));

/***********************************************************************
** Standard header file footer.  
*/

#ifdef __cplusplus
	}
#endif /* __cplusplus */
#endif /* file inclusion */

